package es.misadiaria.misadiaria.commons;

import android.app.DatePickerDialog;
import android.app.Dialog;
import android.os.Bundle;
import android.support.v4.app.DialogFragment;
import android.widget.DatePicker;
import android.widget.TextView;

import java.util.Calendar;
import java.util.GregorianCalendar;

import es.misadiaria.misadiaria.MainActivity;
import es.misadiaria.misadiaria.R;
import es.misadiaria.misadiaria.lecturas.EvangelioActivity;
import es.misadiaria.misadiaria.santoral.SantoralActivity;
import es.misadiaria.misadiaria.utils.MisaDiariaDateUtils;

public class DatePickerFragment extends DialogFragment
        implements DatePickerDialog.OnDateSetListener {

    @Override
    public Dialog onCreateDialog(Bundle savedInstanceState) {
        Calendar calendar = CommonMisaDiariaActivity.getCalendar();
        int year = calendar.get(Calendar.YEAR);
        int month = calendar.get(Calendar.MONTH);
        int day = calendar.get(Calendar.DAY_OF_MONTH);
        return new DatePickerDialog(getActivity(), this, year, month, day);
    }

    public void onDateSet(DatePicker view, int year, int month, int day) {
        setDateSelected(year, month, day);
        if (getActivity() instanceof SantoralActivity) {
            ((SantoralActivity) getActivity()).setSantoral();
        } else if (getActivity() instanceof EvangelioActivity) {
            ((EvangelioActivity) getActivity()).setEvangelio();
        } else if (getActivity() instanceof MainActivity) {
            ((MainActivity) getActivity()).setSantoral();
            ((MainActivity) getActivity()).setEvangelio();
        }
    }

    private void setDateSelected(int year, int month, int day) {
        Calendar calendar = GregorianCalendar.getInstance();
        calendar.set(year, month, day);
        CommonMisaDiariaActivity.setCalendar(calendar);
        TextView fechaEscogida = (TextView) getActivity().findViewById(R.id.fechaEscogida);
        fechaEscogida.setText(MisaDiariaDateUtils.getDaySpanishFormat(CommonMisaDiariaActivity.getCalendar()));
    }

}
