package es.misadiaria.misadiaria.lecturas;

import android.widget.TextView;

import org.apache.commons.io.IOUtils;
import org.apache.commons.lang3.StringUtils;

import java.io.IOException;
import java.io.InputStream;
import java.util.Calendar;
import java.util.List;

import es.misadiaria.misadiaria.R;
import es.misadiaria.misadiaria.commons.CommonMisaDiariaActivity;
import es.misadiaria.misadiaria.commons.MisaDiariaConstants;

public class EvangelioAssetsImpl implements EvangelioFacade, MisaDiariaConstants {

    @Override
    public String getEvangelioDia(CommonMisaDiariaActivity context, Calendar calendar) {
        String result = StringUtils.EMPTY;
        String filename = EVANGELIO_DIRECTORY + getLectura(context, calendar) + TXT;
        InputStream inputStream = null;
        try {
            inputStream = context.getAssets().open(filename);
            result = IOUtils.toString(inputStream, UTF_8);
        } catch (IOException e) {
            TextView mensaje = new TextView(context);
            mensaje.setText(R.string.evangelio_no_disponible);
            result = (String) mensaje.getText();
        } finally {
            IOUtils.closeQuietly(inputStream);
        }
        return result;
    }

    private String getLectura(CommonMisaDiariaActivity context, Calendar calendar) {
        String result = StringUtils.EMPTY;
        String filename = YEARS_DIRECTORY + calendar.get(Calendar.YEAR) + TXT;
        InputStream inputStream = null;
        try {
            inputStream = context.getAssets().open(filename);
            List<String> lines = IOUtils.readLines(inputStream, UTF_8);
            result = lines.get(calendar.get(Calendar.DAY_OF_YEAR) - 1);
        } catch (IOException e) {
            TextView mensaje = new TextView(context);
            mensaje.setText(R.string.evangelio_no_disponible);
            result = (String) mensaje.getText();
        } finally {
            IOUtils.closeQuietly(inputStream);
        }
        return result;
    }

}
