package es.misadiaria.misadiaria.santoral;

import android.widget.TextView;

import org.apache.commons.io.IOUtils;
import org.apache.commons.lang3.StringUtils;

import java.io.IOException;
import java.io.InputStream;
import java.util.Calendar;
import java.util.List;

import es.misadiaria.misadiaria.R;
import es.misadiaria.misadiaria.commons.CommonMisaDiariaActivity;
import es.misadiaria.misadiaria.commons.MisaDiariaConstants;

public class SantoralAssetsImpl implements SantoralFacade, MisaDiariaConstants {

    @Override
    public String getSantoralDia(CommonMisaDiariaActivity context, Calendar calendar) {
        String result = StringUtils.EMPTY;
        String filename = SANTORAL_DIRECTORY + calendar.get(Calendar.MONTH) + TXT;
        InputStream inputStream = null;
        try {
            inputStream = context.getAssets().open(filename);
            List<String> lines = IOUtils.readLines(inputStream, UTF_8);
            result = lines.get(calendar.get(Calendar.DAY_OF_MONTH) - 1);
        } catch (IOException e) {
            TextView mensaje = new TextView(context);
            mensaje.setText(R.string.santoral_no_disponible);
            result = (String) mensaje.getText();
        } finally {
            IOUtils.closeQuietly(inputStream);
        }
        return result;
    }

}
